package lu.etat.pch.convTest;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.Conversation;
import javax.enterprise.context.ConversationScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;

/**
 * Created by schullto on 28/10/2014.
 */
@Named
@ConversationScoped
public class ConversationBean implements Serializable {
    private static final long serialVersionUID = 4771270804699990999L;

    @Inject
    private Conversation conversation;

    private int counter;

    @PostConstruct
    public void postConstruct() {
        System.out.println("ConvBean.postConstruct... (" + this + ")");
        counter = 0;
    }

    @PreDestroy
    public void preDestroy() {
        System.out.println("ConvBean.preDestroy... (" + this + ")");
    }

    public void startConversation() {
        if (conversation.isTransient()) {
            conversation.begin();
        }
    }
    public String endConversation() {
        System.out.println("ConvBean.endConversation...");
        if (!conversation.isTransient()) {
            System.out.println("ConvBean.endConversation.END!!!");
            conversation.end();
        }
        return "step1?faces-redirect=true";
    }

    public void increment() {
        counter++;
    }

    public void decrement() {
        counter--;
    }

    public String gotoStep2() {
        return "step2?faces-redirect=true";
    }
    public String gotoStep3() {
        return "step3?faces-redirect=true";
    }

    public int getCounter() {
        return counter;
    }

    public void setCounter(int counter) {
        this.counter = counter;
    }

    public Conversation getConversation() {
        return conversation;
    }
}
